function ownKeys(object, enumerableOnly) { var keys = Object.keys(object); if (Object.getOwnPropertySymbols) { var symbols = Object.getOwnPropertySymbols(object); if (enumerableOnly) symbols = symbols.filter(function (sym) { return Object.getOwnPropertyDescriptor(object, sym).enumerable; }); keys.push.apply(keys, symbols); } return keys; }

function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i] != null ? arguments[i] : {}; if (i % 2) { ownKeys(Object(source), true).forEach(function (key) { _defineProperty(target, key, source[key]); }); } else if (Object.getOwnPropertyDescriptors) { Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)); } else { ownKeys(Object(source)).forEach(function (key) { Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key)); }); } } return target; }

function _objectWithoutProperties(source, excluded) { if (source == null) return {}; var target = _objectWithoutPropertiesLoose(source, excluded); var key, i; if (Object.getOwnPropertySymbols) { var sourceSymbolKeys = Object.getOwnPropertySymbols(source); for (i = 0; i < sourceSymbolKeys.length; i++) { key = sourceSymbolKeys[i]; if (excluded.indexOf(key) >= 0) continue; if (!Object.prototype.propertyIsEnumerable.call(source, key)) continue; target[key] = source[key]; } } return target; }

function _objectWithoutPropertiesLoose(source, excluded) { if (source == null) return {}; var target = {}; var sourceKeys = Object.keys(source); var key, i; for (i = 0; i < sourceKeys.length; i++) { key = sourceKeys[i]; if (excluded.indexOf(key) >= 0) continue; target[key] = source[key]; } return target; }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

import { createHashHistory, createBrowserHistory, createMemoryHistory } from 'history-fix';
import config from './config';
import { flatten, isAbsoluteUrl, normalizeRoutes, normalizeLocation, resolveRedirect, matchRoutes, isFunction, isLocation, nextTick, once, afterInterceptors, getHostRouterView } from './util';
import routeCache from './route-cache';
import { RouteLazy, hasRouteLazy, hasMatchedRouteLazy } from './route-lazy';
import { getGuardsComponent } from './route-guard';
const HISTORY_METHS = ['push', 'replace', 'go', 'back', 'goBack', 'forward', 'goForward', 'block'];
let idSeed = 1;
export default class ReactViewRouter {
  // React.ComponentClass | null;
  constructor(_ref = {}) {
    let {
      parent = null,
      mode = 'hash',
      basename = '',
      base = ''
    } = _ref,
        options = _objectWithoutProperties(_ref, ["parent", "mode", "basename", "base"]);

    _defineProperty(this, "parent", void 0);

    _defineProperty(this, "options", void 0);

    _defineProperty(this, "mode", void 0);

    _defineProperty(this, "basename", void 0);

    _defineProperty(this, "routes", void 0);

    _defineProperty(this, "plugins", void 0);

    _defineProperty(this, "beforeEachGuards", void 0);

    _defineProperty(this, "afterEachGuards", void 0);

    _defineProperty(this, "prevRoute", void 0);

    _defineProperty(this, "currentRoute", void 0);

    _defineProperty(this, "pendingRoute", void 0);

    _defineProperty(this, "initialRoute", void 0);

    _defineProperty(this, "viewRoot", void 0);

    _defineProperty(this, "errorCallback", void 0);

    _defineProperty(this, "app", void 0);

    _defineProperty(this, "isRunning", void 0);

    _defineProperty(this, "getHostRouterView", void 0);

    _defineProperty(this, "nextTick", void 0);

    _defineProperty(this, "_history", void 0);

    _defineProperty(this, "_unlisten", void 0);

    _defineProperty(this, "__unblock", void 0);

    _defineProperty(this, "id", void 0);

    _defineProperty(this, "_nexting", void 0);

    _defineProperty(this, "ReactVueLike", void 0);

    _defineProperty(this, "_interceptorCounter", void 0);

    options.getUserConfirmation = this._handleRouteInterceptor.bind(this);
    this.parent = parent !== this ? parent : null;
    this.id = idSeed++;
    this.options = options;
    this.mode = mode;
    this.basename = basename || base;
    this.routes = [];
    this.plugins = [];
    this.beforeEachGuards = [];
    this.afterEachGuards = [];
    this.initialRoute = {};
    this.prevRoute = null;
    this.currentRoute = null;
    this.pendingRoute = null;
    this.viewRoot = null;
    this.errorCallback = null;
    this.app = null;
    this._nexting = null;
    this._history = null;
    this.isRunning = false;
    this._interceptorCounter = 0;
    this.getHostRouterView = getHostRouterView;
    this.nextTick = nextTick.bind(this); // this.states = [];
    // this.stateOrigin = this.history.length;

    this.use(options);
    if (!options.manual) this.start();
  }

  get history() {
    if (this._history) return this._history;
    const options = this.options;

    if (options.history) {
      if (options.history instanceof ReactViewRouter) {
        this._history = options.history.history;
        this.mode = options.history.mode;
      } else this._history = options.history;
    } else {
      switch (this.mode) {
        case 'browser':
        case 'history':
          this._history = createBrowserHistory(this.options);
          break;

        case 'memory':
        case 'abstract':
          this._history = createMemoryHistory(this.options);
          break;

        default:
          this._history = createHashHistory(this.options);
      }
    }

    HISTORY_METHS.forEach(key => this[key] && (this[key] = this[key].bind(this)));
    return this._history;
  }

  start(_ref2 = {}) {
    let {
      parent,
      mode,
      basename,
      base
    } = _ref2,
        options = _objectWithoutProperties(_ref2, ["parent", "mode", "basename", "base"]);

    this.stop();
    Object.assign(this.options, options);
    if (parent !== undefined && parent !== this) this.parent = parent;
    if (basename !== undefined) this.basename = basename;
    if (base !== undefined) this.basename = base;
    if (mode !== undefined) this.mode = mode;
    this._unlisten = this.history.listen(location => this.updateRoute(location));
    this._unblock = this.history.block(location => routeCache.create(location, this.id));
    if (this.routes.length) this._refreshInitialRoute();
    this.isRunning = true;
  }

  stop() {
    if (this._unlisten) {
      this._unlisten();

      this._unlisten = undefined;
    }

    if (this._unblock) {
      this._unblock();

      this._unblock = undefined;
    }

    this._history = null;
    this.isRunning = false;
    this._interceptorCounter = 0;
  }

  use(_ref3) {
    let {
      routes,
      inheritProps,
      install
    } = _ref3,
        restOptions = _objectWithoutProperties(_ref3, ["routes", "inheritProps", "install"]);

    if (routes) {
      this.routes = routes ? normalizeRoutes(routes) : [];
      if (this._history) this._refreshInitialRoute();
    }

    if (inheritProps !== undefined) config.inheritProps = inheritProps;
    Object.assign(config, restOptions);
    if (install) this.install = install.bind(this);
  }

  plugin(plugin) {
    if (~this.plugins.indexOf(plugin)) return;
    this.plugins.push(plugin);
    if (plugin.install) plugin.install(this);
    return function () {
      const idx = this.plugins.indexOf(plugin);

      if (~idx) {
        this.plugins.splice(idx, 1);
        if (plugin.uninstall) plugin.uninstall(this);
      }
    };
  }

  _refreshInitialRoute() {
    const location = _objectSpread({}, this.history.location);

    if (window && window.location && window.location.search !== location.search) {
      let search = window.location.search;

      if (window.location.hash) {
        let [, hashSearch] = window.location.hash.match(/#[a-z0-9-_/]+\?(.+)/i) || [];
        if (hashSearch) search = search + (search ? '&' : '?') + hashSearch;
        location.search = search;
      }
    }

    this.updateRoute(location);
    this.initialRoute = this.createRoute(this._transformLocation(location));
  }

  _callEvent(event, ...args) {
    let plugin = null;

    try {
      let ret;
      this.plugins.forEach(p => {
        plugin = p;
        const newRet = p[event] && p[event].call(p, ...args, ret);
        if (newRet !== undefined) ret = newRet;
      });
      return ret;
    } catch (ex) {
      if (plugin && plugin.name && ex && ex.message) {
        ex.message = `[${plugin.name}:${event}]${ex.message}`;
      }

      throw ex;
    }
  }

  _isReactVueLike(comp) {
    return comp && this.ReactVueLike && ( // eslint-disable-next-line no-proto
    comp.__proto__ && comp._isVueLike || comp.__vuelike || comp.__vuelikeClass || comp.prototype instanceof this.ReactVueLike);
  }

  _getComponentGurads(mr, guardName, bindInstance = true) {
    let ret = [];
    const componentInstances = mr.componentInstances; // route config

    const routeGuardName = guardName.replace('Route', '');
    const r = mr.config;
    const guards = r[routeGuardName];
    if (guards) ret.push(guards);

    const toResovle = (c, key) => {
      let ret = [];
      const cc = c.__component ? getGuardsComponent(c, true) : c;
      const cg = c.__guards && c.__guards[guardName];
      if (cg) ret.push(cg);
      let ccg = cc && cc.prototype && cc.prototype[guardName];

      if (ccg) {
        if (this.ReactVueLike && !ccg.isMobxFlow && cc.__flows && ~cc.__flows.indexOf(guardName)) ccg = this.ReactVueLike.flow(ccg);
        ret.push(ccg);
      }

      if (this._isReactVueLike(cc) && Array.isArray(cc.mixins)) {
        cc.mixins.forEach(m => {
          let ccg = m[guardName] || m.prototype && m.prototype[guardName];
          if (!ccg) return;
          if (this.ReactVueLike && !ccg.isMobxFlow && m.__flows && ~m.__flows.indexOf(guardName)) ccg = this.ReactVueLike.flow(ccg);
          ret.push(ccg);
        });
      }

      const ci = componentInstances[key];

      if (bindInstance) {
        if (isFunction(bindInstance)) ret = ret.map(v => bindInstance(v, key, ci, mr)).filter(Boolean);else if (ci) ret = ret.map(v => v.bind(ci));
      }

      ret = flatten(ret);
      ret.forEach(v => v.route = mr);
      return ret;
    }; // route component


    r.components && Object.keys(r.components).forEach(key => {
      const c = r.components[key];
      if (!c) return;

      if (c instanceof RouteLazy) {
        const lazyResovle = async (interceptors, index) => {
          let nc = await c.toResolve(r, key);
          nc = this._callEvent('onResolveComponent', nc, r) || nc;
          let ret = toResovle(nc, key);
          interceptors.splice(index, 1, ...ret);
          return interceptors[index];
        };

        lazyResovle.lazy = true;
        lazyResovle.route = mr;
        ret.push(lazyResovle);
      } else ret.push(...toResovle(c, key));
    });
    return ret;
  }

  _getRouteComponentGurads(matched, guardName, reverse = false, bindInstance = true) {
    let ret = [];
    if (reverse) matched = matched.reverse();
    matched.forEach(r => {
      let guards = this._getComponentGurads(r, guardName, bindInstance);

      ret.push(...guards);
    });
    return ret;
  }

  _getSameMatched(route, compare) {
    const ret = [];
    if (!compare) return [];
    route && route.matched.some((tr, i) => {
      let fr = compare.matched[i];
      if (tr.path !== fr.path) return true;
      ret.push(tr);
    });
    return ret.filter(r => !r.redirect);
  }

  _getChangeMatched(route, compare, options = {}) {
    const ret = [];
    if (!compare) return [...route.matched];
    let start = false;
    route && route.matched.some((tr, i) => {
      let fr = compare.matched[i];

      if (!start) {
        start = options.containLazy && hasRouteLazy(tr) || !fr || fr.path !== tr.path;
        if (!start) return;
      }

      ret.push(tr);
      return typeof options.count === 'number' && ret.length === options.count;
    });
    return ret.filter(r => !r.redirect);
  }

  _getBeforeEachGuards(to, from, current = null) {
    const ret = [...this.beforeEachGuards];
    const view = this;

    if (from) {
      const fm = this._getChangeMatched(from, to).filter(r => Object.keys(r.componentInstances).some(key => r.componentInstances[key]));

      ret.push(...this._getRouteComponentGurads(fm, 'beforeRouteLeave', true, (fn, name, ci, r) => function beforeRouteLeaveWraper(to, from, next) {
        return fn.call(ci, to, from, (cb, ...args) => {
          if (isFunction(cb)) {
            const _cb = cb;

            cb = (...as) => {
              const res = _cb(...as);

              view._callEvent('onRouteLeaveNext', r, ci, res);

              return res;
            };
          }

          return next(cb, ...args);
        }, r);
      }));
    }

    if (to) {
      let tm = this._getChangeMatched(to, from, {
        containLazy: true
      });

      tm.forEach(r => {
        let guards = this._getComponentGurads(r, 'beforeRouteEnter', (fn, name) => function beforeRouteEnterWraper(to, from, next) {
          return fn(to, from, (cb, ...args) => {
            if (isFunction(cb)) {
              const _cb = cb;

              r.config._pending.completeCallbacks[name] = ci => {
                const res = _cb(ci);

                view._callEvent('onRouteEnterNext', r, ci, res);

                return res;
              };

              cb = undefined;
            }

            return next(cb, ...args);
          }, r);
        });

        ret.push(...guards);
      });
    }

    return flatten(ret);
  } // _getBeforeResolveGuards(to: Route, from: Route | null) {
  //   const ret = [...this.beforeResolveGuards];
  //   const view = this;
  //   if (from) {
  //     const fm = this._getChangeMatched(from, to)
  //       .filter(r => Object.keys(r.componentInstances).some(key => r.componentInstances[key]));
  //     ret.push(...(this._getRouteComponentGurads(fm, 'beforeRouteResolve'));
  //   }
  //   if (to) {
  //     let tm = this._getChangeMatched(to, from, { containLazy: true });
  //     tm.forEach(r => {
  //       let guards = this._getComponentGurads(
  //         r,
  //         'beforeRouteEnter',
  //         (fn, name) => (function beforeRouteEnterWraper(to: Route, from: Route | null, next: RouteNextFn) {
  //           return (fn as RouteBeforeGuardFn)(to, from, (cb, ...args) => {
  //             if (isFunction(cb)) {
  //               const _cb = cb;
  //               r.config._pending.completeCallbacks[name] = ci => {
  //                 const res = _cb(ci);
  //                 view._callEvent('onRouteEnterNext', r, ci, res);
  //                 return res;
  //               };
  //               cb = undefined;
  //             }
  //             return next(cb, ...args);
  //           }, r);
  //         })
  //       ) as RouteBeforeGuardFn[];
  //       ret.push(...guards);
  //     });
  //   }
  //   return flatten(ret);
  // }


  _getRouteUpdateGuards(to, from) {
    const ret = [];
    const fm = [];
    to && to.matched.some((tr, i) => {
      let fr = from && from.matched[i];
      if (!fr || fr.path !== tr.path) return true;
      fm.push(fr);
    });
    ret.push(...this._getRouteComponentGurads(fm.filter(r => !r.redirect), 'beforeRouteUpdate', true));
    return ret;
  }

  _getAfterEachGuards(to, from) {
    const ret = [];

    if (from) {
      const fm = this._getChangeMatched(from, to).filter(r => Object.keys(r.componentInstances).some(key => r.componentInstances[key]));

      ret.push(...this._getRouteComponentGurads(fm, 'afterRouteLeave', true));
    }

    ret.push(...this.afterEachGuards);
    return flatten(ret);
  }

  _transformLocation(location) {
    if (!location) return location;

    if (this.basename) {
      if (location.pathname.indexOf(this.basename) !== 0) return null;
      location = _objectSpread({}, location);
      location.pathname = location.pathname.substr(this.basename.length) || '/';
      if (location.path !== undefined) location.path = location.pathname;
    }

    return location;
  }

  async _handleRouteInterceptor(location, callback, isInit = false) {
    if (!this.isRunning) return callback(false);
    if (typeof location === 'string') location = routeCache.flush(location);
    location = this._transformLocation(location);
    if (!location) return callback(true);
    if (!isInit && !location.onInit && (!this.viewRoot || !this.viewRoot.state._routerInited)) return callback(false);

    this._callEvent('onRouteing', true);

    try {
      return await this._internalHandleRouteInterceptor(location, callback, isInit);
    } finally {
      this._callEvent('onRouteing', false);
    }
  }

  async _getInterceptor(interceptors, index) {
    let interceptor = interceptors[index];

    while (interceptor && interceptor.lazy) {
      interceptor = await interceptor(interceptors, index);
    }

    return interceptor;
  }

  async _routetInterceptors(interceptors, to, from, next) {
    const isBlock = (v, interceptor) => {
      let _isLocation = typeof v === 'string' || isLocation(v);

      if (_isLocation && interceptor) {
        let _to = normalizeLocation(v, interceptor.route);

        v = _to && this.createRoute(_to);

        if (v && v.fullPath === to.fullPath) {
          v = undefined;
          _isLocation = false;
        }
      }

      return !this._history || v === false || _isLocation || v instanceof Error;
    };

    async function beforeInterceptor(interceptor, index, to, from, next) {
      if (!interceptor) return next();
      const nextWrapper = this._nexting = once(async f1 => {
        if (isBlock.call(this, f1, interceptor)) return next(f1);
        if (f1 === true) f1 = undefined;
        let nextInterceptor = await this._getInterceptor(interceptors, ++index);
        if (!nextInterceptor) return next(res => isFunction(f1) && f1(res));

        try {
          return await beforeInterceptor.call(this, nextInterceptor, index, to, from, res => {
            let ret = next(res);
            if (interceptor.global) isFunction(f1) && f1(res);
            return ret;
          });
        } catch (ex) {
          console.error(ex);
          next(typeof ex === 'string' ? new Error(ex) : ex);
        }
      });
      return await interceptor(to, from, nextWrapper, interceptor.route);
    }

    if (next) await beforeInterceptor.call(this, (await this._getInterceptor(interceptors, 0)), 0, to, from, next);else afterInterceptors.call(this, interceptors, to, from);
  }

  _internalHandleRouteInterceptor(location, callback, isInit = false) {
    let isContinue = false;
    let interceptorCounter = ++this._interceptorCounter;

    try {
      const to = this.createRoute(location);
      const from = isInit ? null : to.redirectedFrom || this.currentRoute;
      const current = this.currentRoute;

      const checkIsContinue = () => this.isRunning && interceptorCounter === this._interceptorCounter && Boolean(this.viewRoot && this.viewRoot._isMounted);

      const afterCallback = (isContinue, to) => {
        if (isContinue) to.onInit && to.onInit(isContinue, to);else to.onAbort && to.onAbort(isContinue, to);
        this.nextTick(() => {
          if (!isInit && (!current || current.fullPath !== to.fullPath)) {
            this._routetInterceptors(this._getRouteUpdateGuards(to, current), to, current);
          }
        });
      };

      if (!to) return;

      if (from && to.path === from.path) {
        isContinue = checkIsContinue();
        callback(isContinue, null);
        afterCallback(isContinue, to);
        return;
      }

      let fallbackView = null;

      if (hasMatchedRouteLazy(to.matched)) {
        fallbackView = this.viewRoot;

        this._getSameMatched(isInit ? null : this.currentRoute, to).reverse().some(m => {
          if (!m.viewInstances.default || !m.viewInstances.default.props.fallback) return;
          return fallbackView = m.viewInstances.default;
        });
      }

      fallbackView && fallbackView._updateResolving(true);

      this._routetInterceptors(this._getBeforeEachGuards(to, from, current), to, from, ok => {
        this._nexting = null;
        fallbackView && setTimeout(() => fallbackView && fallbackView._isMounted && fallbackView._updateResolving(false), 0);
        if (typeof ok === 'string') ok = {
          path: ok
        };
        isContinue = checkIsContinue() && Boolean(ok === undefined || ok && !(ok instanceof Error) && !isLocation(ok));
        const toLast = to.matched[to.matched.length - 1];

        if (isContinue && toLast && toLast.config.exact && toLast.redirect) {
          ok = resolveRedirect(toLast.redirect, toLast, to);
          if (ok) isContinue = false;
        }

        callback(isContinue, to);
        afterCallback(isContinue, to);

        if (!isContinue) {
          if (isLocation(ok)) {
            return this.redirect(ok, to.onComplete, to.onAbort, to.onInit || (isInit ? callback : null), to);
          }

          if (ok instanceof Error) this.errorCallback && this.errorCallback(ok);
          return;
        }

        this.nextTick(() => {
          if (isFunction(ok)) ok = ok(to);
          if (to && isFunction(to.onComplete)) to.onComplete(Boolean(ok), to);

          this._routetInterceptors(this._getAfterEachGuards(to, current), to, current);
        });
      });
    } catch (ex) {
      console.error(ex);
      if (!isContinue) callback(isContinue, null);
    }
  }

  _go(to, onComplete, onAbort, onInit, replace) {
    return new Promise((resolve, reject) => {
      let _to = normalizeLocation(to, this.currentRoute, false, this.basename);

      function doComplete(res, _to) {
        onComplete && onComplete(res, _to);
        resolve(res);
      }

      function doAbort(res, _to) {
        onAbort && onAbort(res, _to);
        reject(res === false && _to === null ? new Error('to path cannot be empty!') : res);
      }

      if (!this.isRunning) return doAbort(new Error('router is not running!'), null);
      if (!_to) return doAbort(false, null);
      if (isFunction(onComplete)) _to.onComplete = once(doComplete);
      if (isFunction(onAbort)) _to.onAbort = once(doAbort);
      if (onInit) _to.onInit = onInit;
      if (this._nexting) return this._nexting(_to);
      if (replace) _to.isReplace = true;

      if (!this.viewRoot || !onInit && !this.viewRoot.state._routerInited) {
        return this.pendingRoute = _to;
      }

      if (replace) {
        if (_to.fullPath && isAbsoluteUrl(_to.fullPath)) location.replace(_to.fullPath);else this.history.replace(_to);
      } else {
        if (_to.fullPath && isAbsoluteUrl(_to.fullPath)) location.href = _to.fullPath;else this.history.push(_to);
      }
    });
  }

  _replace(to, onComplete, onAbort, onInit) {
    return this._go(to, onComplete, onAbort, onInit, true);
  }

  _push(to, onComplete, onAbort, onInit) {
    return this._go(to, onComplete, onAbort, onInit);
  }

  createMatchedRoute(route, match) {
    let {
      url,
      params
    } = match || {
      url: '',
      params: {}
    };
    let {
      path,
      subpath,
      meta,
      redirect,
      index,
      depth
    } = route;
    return {
      url,
      path,
      subpath,
      depth,
      meta,
      index,
      redirect,
      params,
      componentInstances: {},
      viewInstances: {},
      config: route
    };
  }

  getMatched(to, from, parent = null) {
    if (!from) from = this.currentRoute;

    function copyInstance(to, from) {
      if (!from) return;
      if (from.componentInstances) to.componentInstances = from.componentInstances;
      if (from.viewInstances) to.viewInstances = from.viewInstances;
    }

    let matched = matchRoutes(this.routes, to, parent);
    return matched.map(({
      route,
      match
    }, i) => {
      let ret = this.createMatchedRoute(route, match);

      if (from) {
        const fr = from.matched[i];
        const tr = matched[i];
        if (fr && tr && fr.path === tr.route.path) copyInstance(ret, fr);
      }

      return ret;
    });
  }

  getMatchedComponents(to, from, parent) {
    return this.getMatched(to, from, parent).map(r => r.componentInstances.default).filter(Boolean);
  }

  getMatchedViews(to, from, parent) {
    return this.getMatched(to, from, parent).map(r => r.viewInstances.default).filter(Boolean);
  }

  createRoute(to, from = null) {
    if (!from && to) from = to.redirectedFrom || this.currentRoute;
    const matched = to ? this.getMatched(to, from) : [];
    const last = matched.length ? matched[matched.length - 1] : {
      url: '',
      params: {},
      meta: {}
    };
    const {
      search = '',
      query,
      path = '',
      onAbort,
      onComplete,
      isRedirect,
      isReplace,
      onInit
    } = to || {};
    const ret = {
      action: this.history.action,
      url: last.url,
      basename: this.basename,
      path,
      search,
      fullPath: `${path}${search}`,
      isRedirect: Boolean(isRedirect),
      isReplace: Boolean(isReplace),
      query: query || (search ? config.parseQuery(search.substr(1)) : {}),
      params: last.params || {},
      matched,
      meta: last.meta || {},
      onAbort,
      onComplete
    }; // Object.defineProperty(ret, 'fullPath', {
    //   enumerable: true,
    //   configurable: true,
    //   get() {
    //     return `${to.path}${to.search}`;
    //   }
    // });

    Object.defineProperty(ret, 'origin', {
      configurable: true,
      value: to
    });

    if (isRedirect && from) {
      ret.redirectedFrom = from;
      if (!ret.onAbort && from.onAbort) ret.onAbort = from.onAbort;
      if (!ret.onComplete && from.onComplete) ret.onComplete = from.onComplete;
      if (!ret.onInit && onInit) ret.onInit = onInit;
    }

    return ret;
  }

  updateRoute(location) {
    location = location && this._transformLocation(location);
    if (!location) return;
    this.prevRoute = this.currentRoute;
    this.currentRoute = this.createRoute(location, this.prevRoute); // const statesLen = this.states.length + this.stateOrigin;
    // const historyLen = this.history.length - this.stateOrigin;
    // if (this.history.action === 'POP') {
    //   this.currentRoute.state = this.states[historyLen];
    //   if (statesLen > this.history.length) this.states.splice(historyLen);
    // } else {
    //   if (statesLen > this.history.length) this.states.splice(historyLen - 1);
    //   this.states.push(this.currentRoute.state);
    // }

    let tm = this.prevRoute && this._getChangeMatched(this.prevRoute, this.currentRoute, {
      count: 1
    })[0];

    let callback = () => this._callEvent('onRouteChange', this.currentRoute, this);

    if (tm) {
      let keys = Object.keys(tm.viewInstances);

      if (keys.length) {
        keys.forEach((key, i) => {
          tm && tm.viewInstances[key]._refreshCurrentRoute(undefined, undefined, i === keys.length - 1 ? callback : undefined);
        });
      } else callback();
    } else if (this.viewRoot) this.viewRoot._refreshCurrentRoute(undefined, undefined, callback);else callback();
  }

  push(to, onComplete, onAbort) {
    return this._push(to, onComplete, onAbort);
  }

  replace(to, onComplete, onAbort) {
    return this._replace(to, onComplete, onAbort);
  }

  redirect(to, onComplete, onAbort, onInit, from) {
    let _to = normalizeLocation(to);

    if (!_to) return;
    _to.isRedirect = true;
    _to.redirectedFrom = from || this.currentRoute;
    return _to.isReplace ? this._replace(_to, onComplete, onAbort, onInit) : this._push(_to, onComplete, onAbort, onInit);
  }

  go(n) {
    return this.history.go(n);
  }

  back() {
    return this.history.goBack();
  }

  goBack() {
    return this.history.goBack();
  }

  forward() {
    return this.history.goForward();
  }

  goForward() {
    return this.history.goForward();
  }

  beforeEach(guard) {
    if (!guard || typeof guard !== 'function') return;
    let i = this.beforeEachGuards.indexOf(guard);
    if (~i) this.beforeEachGuards.splice(i, 1);
    guard.global = true;
    this.beforeEachGuards.push(guard);
  }

  afterEach(guard) {
    if (!guard || typeof guard !== 'function') return;
    let i = this.afterEachGuards.indexOf(guard);
    if (~i) this.afterEachGuards.splice(i, 1);
    guard.global = true;
    this.afterEachGuards.push(guard);
  }

  addRoutes(routes, parentRoute, name = 'default') {
    if (!routes) return;
    if (!Array.isArray(routes)) routes = [routes];
    routes = normalizeRoutes(routes, parentRoute);
    let children = parentRoute ? parentRoute.children : this.routes;
    if (isFunction(children)) children = children();
    if (!children) return;
    routes.forEach(r => {
      let i = children.findIndex(v => v.path === r.path);
      if (~i) children.splice(i, 1, r);else children.push(r);
    });
    if (parentRoute && parentRoute.viewInstances[name]) parentRoute.viewInstances[name].setState({
      routes
    });else if (this.state.viewRoot) this.state.viewRoot.setState({
      routes
    });
  }

  parseQuery(query) {
    return config.parseQuery(query);
  }

  stringifyQuery(obj) {
    return config.stringifyQuery(obj);
  }

  onError(callback) {
    this.errorCallback = callback;
  }

  install(ReactVueLike, {
    App
  }) {
    this.ReactVueLike = ReactVueLike;
    this.App = App;
    if (!App.inherits) App.inherits = {};
    App.inherits.$router = this;
    App.inherits.$route = ReactVueLike.observable(this.currentRoute || {});
    config.inheritProps = false;

    if (!ReactVueLike.config.inheritMergeStrategies.$route) {
      ReactVueLike.config.inheritMergeStrategies.$route = config.routeMergeStrategie;
    }

    const router = this;
    this.plugin({
      name: 'react-view-router-vue-like-plugin',
      onRouteChange: ReactVueLike.action(`[react-view-router][${this.id}]onRouteChange`, function (newVal) {
        if (router.app) {
          router.app.$route = ReactVueLike.observable(newVal, {}, {
            deep: false
          });
        } else {
          App.inherits.$route = ReactVueLike.observable(newVal, {}, {
            deep: false
          });
          if (App.inherits.$router !== router) App.inherits.$router = router;
        }
      })
    });
  }

}