"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

require("core-js/modules/es6.string.iterator");

require("core-js/modules/es6.array.from");

require("core-js/modules/es6.regexp.to-string");

require("core-js/modules/es7.symbol.async-iterator");

require("core-js/modules/es7.object.get-own-property-descriptors");

require("core-js/modules/es6.symbol");

require("core-js/modules/es6.array.find-index");

require("core-js/modules/es6.promise");

require("regenerator-runtime/runtime");

require("core-js/modules/web.dom.iterable");

require("core-js/modules/es6.array.iterator");

require("core-js/modules/es6.object.to-string");

require("core-js/modules/es6.object.keys");

require("core-js/modules/es6.regexp.replace");

require("core-js/modules/es6.regexp.match");

require("core-js/modules/es6.regexp.search");

require("core-js/modules/es6.object.assign");

var _historyFix = require("history-fix");

var _config = _interopRequireDefault(require("./config"));

var _util = require("./util");

var _routeCache = _interopRequireDefault(require("./route-cache"));

var _routeLazy = require("./route-lazy");

var _routeGuard = require("./route-guard");

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _toConsumableArray(arr) { return _arrayWithoutHoles(arr) || _iterableToArray(arr) || _nonIterableSpread(); }

function _nonIterableSpread() { throw new TypeError("Invalid attempt to spread non-iterable instance"); }

function _iterableToArray(iter) { if (Symbol.iterator in Object(iter) || Object.prototype.toString.call(iter) === "[object Arguments]") return Array.from(iter); }

function _arrayWithoutHoles(arr) { if (Array.isArray(arr)) { for (var i = 0, arr2 = new Array(arr.length); i < arr.length; i++) { arr2[i] = arr[i]; } return arr2; } }

function _slicedToArray(arr, i) { return _arrayWithHoles(arr) || _iterableToArrayLimit(arr, i) || _nonIterableRest(); }

function _nonIterableRest() { throw new TypeError("Invalid attempt to destructure non-iterable instance"); }

function _iterableToArrayLimit(arr, i) { if (!(Symbol.iterator in Object(arr) || Object.prototype.toString.call(arr) === "[object Arguments]")) { return; } var _arr = []; var _n = true; var _d = false; var _e = undefined; try { for (var _i = arr[Symbol.iterator](), _s; !(_n = (_s = _i.next()).done); _n = true) { _arr.push(_s.value); if (i && _arr.length === i) break; } } catch (err) { _d = true; _e = err; } finally { try { if (!_n && _i["return"] != null) _i["return"](); } finally { if (_d) throw _e; } } return _arr; }

function _arrayWithHoles(arr) { if (Array.isArray(arr)) return arr; }

function ownKeys(object, enumerableOnly) { var keys = Object.keys(object); if (Object.getOwnPropertySymbols) { var symbols = Object.getOwnPropertySymbols(object); if (enumerableOnly) symbols = symbols.filter(function (sym) { return Object.getOwnPropertyDescriptor(object, sym).enumerable; }); keys.push.apply(keys, symbols); } return keys; }

function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i] != null ? arguments[i] : {}; if (i % 2) { ownKeys(Object(source), true).forEach(function (key) { _defineProperty(target, key, source[key]); }); } else if (Object.getOwnPropertyDescriptors) { Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)); } else { ownKeys(Object(source)).forEach(function (key) { Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key)); }); } } return target; }

function _objectWithoutProperties(source, excluded) { if (source == null) return {}; var target = _objectWithoutPropertiesLoose(source, excluded); var key, i; if (Object.getOwnPropertySymbols) { var sourceSymbolKeys = Object.getOwnPropertySymbols(source); for (i = 0; i < sourceSymbolKeys.length; i++) { key = sourceSymbolKeys[i]; if (excluded.indexOf(key) >= 0) continue; if (!Object.prototype.propertyIsEnumerable.call(source, key)) continue; target[key] = source[key]; } } return target; }

function _objectWithoutPropertiesLoose(source, excluded) { if (source == null) return {}; var target = {}; var sourceKeys = Object.keys(source); var key, i; for (i = 0; i < sourceKeys.length; i++) { key = sourceKeys[i]; if (excluded.indexOf(key) >= 0) continue; target[key] = source[key]; } return target; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } }

function _createClass(Constructor, protoProps, staticProps) { if (protoProps) _defineProperties(Constructor.prototype, protoProps); if (staticProps) _defineProperties(Constructor, staticProps); return Constructor; }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

var HISTORY_METHS = ['push', 'replace', 'go', 'back', 'goBack', 'forward', 'goForward', 'block'];
var idSeed = 1;

var ReactViewRouter =
/*#__PURE__*/
function () {
  function ReactViewRouter() {
    var _ref = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : {},
        _ref$parent = _ref.parent,
        parent = _ref$parent === void 0 ? null : _ref$parent,
        _ref$mode = _ref.mode,
        mode = _ref$mode === void 0 ? 'hash' : _ref$mode,
        _ref$basename = _ref.basename,
        basename = _ref$basename === void 0 ? '' : _ref$basename,
        _ref$base = _ref.base,
        base = _ref$base === void 0 ? '' : _ref$base,
        options = _objectWithoutProperties(_ref, ["parent", "mode", "basename", "base"]);

    _classCallCheck(this, ReactViewRouter);

    _defineProperty(this, "parent", void 0);

    _defineProperty(this, "options", void 0);

    _defineProperty(this, "mode", void 0);

    _defineProperty(this, "basename", void 0);

    _defineProperty(this, "routes", void 0);

    _defineProperty(this, "plugins", void 0);

    _defineProperty(this, "beforeEachGuards", void 0);

    _defineProperty(this, "afterEachGuards", void 0);

    _defineProperty(this, "prevRoute", void 0);

    _defineProperty(this, "currentRoute", void 0);

    _defineProperty(this, "pendingRoute", void 0);

    _defineProperty(this, "initialRoute", void 0);

    _defineProperty(this, "viewRoot", void 0);

    _defineProperty(this, "errorCallback", void 0);

    _defineProperty(this, "app", void 0);

    _defineProperty(this, "isRunning", void 0);

    _defineProperty(this, "getHostRouterView", void 0);

    _defineProperty(this, "nextTick", void 0);

    _defineProperty(this, "_history", void 0);

    _defineProperty(this, "_unlisten", void 0);

    _defineProperty(this, "__unblock", void 0);

    _defineProperty(this, "id", void 0);

    _defineProperty(this, "_nexting", void 0);

    _defineProperty(this, "ReactVueLike", void 0);

    _defineProperty(this, "_interceptorCounter", void 0);

    options.getUserConfirmation = this._handleRouteInterceptor.bind(this);
    this.parent = parent !== this ? parent : null;
    this.id = idSeed++;
    this.options = options;
    this.mode = mode;
    this.basename = basename || base;
    this.routes = [];
    this.plugins = [];
    this.beforeEachGuards = [];
    this.afterEachGuards = [];
    this.initialRoute = {};
    this.prevRoute = null;
    this.currentRoute = null;
    this.pendingRoute = null;
    this.viewRoot = null;
    this.errorCallback = null;
    this.app = null;
    this._nexting = null;
    this._history = null;
    this.isRunning = false;
    this._interceptorCounter = 0;
    this.getHostRouterView = _util.getHostRouterView;
    this.nextTick = _util.nextTick.bind(this); // this.states = [];
    // this.stateOrigin = this.history.length;

    this.use(options);
    if (!options.manual) this.start();
  }

  _createClass(ReactViewRouter, [{
    key: "start",
    value: function start() {
      var _this = this;

      var _ref2 = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : {},
          parent = _ref2.parent,
          mode = _ref2.mode,
          basename = _ref2.basename,
          base = _ref2.base,
          options = _objectWithoutProperties(_ref2, ["parent", "mode", "basename", "base"]);

      this.stop();
      Object.assign(this.options, options);
      if (parent !== undefined && parent !== this) this.parent = parent;
      if (basename !== undefined) this.basename = basename;
      if (base !== undefined) this.basename = base;
      if (mode !== undefined) this.mode = mode;
      this._unlisten = this.history.listen(function (location) {
        return _this.updateRoute(location);
      });
      this._unblock = this.history.block(function (location) {
        return _routeCache.default.create(location, _this.id);
      });
      if (this.routes.length) this._refreshInitialRoute();
      this.isRunning = true;
    }
  }, {
    key: "stop",
    value: function stop() {
      if (this._unlisten) {
        this._unlisten();

        this._unlisten = undefined;
      }

      if (this._unblock) {
        this._unblock();

        this._unblock = undefined;
      }

      this._history = null;
      this.isRunning = false;
      this._interceptorCounter = 0;
    }
  }, {
    key: "use",
    value: function use(_ref3) {
      var routes = _ref3.routes,
          inheritProps = _ref3.inheritProps,
          install = _ref3.install,
          restOptions = _objectWithoutProperties(_ref3, ["routes", "inheritProps", "install"]);

      if (routes) {
        this.routes = routes ? (0, _util.normalizeRoutes)(routes) : [];
        if (this._history) this._refreshInitialRoute();
      }

      if (inheritProps !== undefined) _config.default.inheritProps = inheritProps;
      Object.assign(_config.default, restOptions);
      if (install) this.install = install.bind(this);
    }
  }, {
    key: "plugin",
    value: function plugin(_plugin) {
      if (~this.plugins.indexOf(_plugin)) return;
      this.plugins.push(_plugin);
      if (_plugin.install) _plugin.install(this);
      return function () {
        var idx = this.plugins.indexOf(_plugin);

        if (~idx) {
          this.plugins.splice(idx, 1);
          if (_plugin.uninstall) _plugin.uninstall(this);
        }
      };
    }
  }, {
    key: "_refreshInitialRoute",
    value: function _refreshInitialRoute() {
      var location = _objectSpread({}, this.history.location);

      if (window && window.location && window.location.search !== location.search) {
        var search = window.location.search;

        if (window.location.hash) {
          var _ref4 = window.location.hash.match(/#[a-z0-9-_/]+\?(.+)/i) || [],
              _ref5 = _slicedToArray(_ref4, 2),
              hashSearch = _ref5[1];

          if (hashSearch) search = search + (search ? '&' : '?') + hashSearch;
          location.search = search;
        }
      }

      this.updateRoute(location);
      this.initialRoute = this.createRoute(this._transformLocation(location));
    }
  }, {
    key: "_callEvent",
    value: function _callEvent(event) {
      for (var _len = arguments.length, args = new Array(_len > 1 ? _len - 1 : 0), _key = 1; _key < _len; _key++) {
        args[_key - 1] = arguments[_key];
      }

      var plugin = null;

      try {
        var ret;
        this.plugins.forEach(function (p) {
          var _p$event;

          plugin = p;

          var newRet = p[event] && (_p$event = p[event]).call.apply(_p$event, [p].concat(args, [ret]));

          if (newRet !== undefined) ret = newRet;
        });
        return ret;
      } catch (ex) {
        if (plugin && plugin.name && ex && ex.message) {
          ex.message = "[".concat(plugin.name, ":").concat(event, "]").concat(ex.message);
        }

        throw ex;
      }
    }
  }, {
    key: "_isReactVueLike",
    value: function _isReactVueLike(comp) {
      return comp && this.ReactVueLike && ( // eslint-disable-next-line no-proto
      comp.__proto__ && comp._isVueLike || comp.__vuelike || comp.__vuelikeClass || comp.prototype instanceof this.ReactVueLike);
    }
  }, {
    key: "_getComponentGurads",
    value: function _getComponentGurads(mr, guardName) {
      var _this2 = this;

      var bindInstance = arguments.length > 2 && arguments[2] !== undefined ? arguments[2] : true;
      var ret = [];
      var componentInstances = mr.componentInstances; // route config

      var routeGuardName = guardName.replace('Route', '');
      var r = mr.config;
      var guards = r[routeGuardName];
      if (guards) ret.push(guards);

      var toResovle = function toResovle(c, key) {
        var ret = [];
        var cc = c.__component ? (0, _routeGuard.getGuardsComponent)(c, true) : c;
        var cg = c.__guards && c.__guards[guardName];
        if (cg) ret.push(cg);
        var ccg = cc && cc.prototype && cc.prototype[guardName];

        if (ccg) {
          if (_this2.ReactVueLike && !ccg.isMobxFlow && cc.__flows && ~cc.__flows.indexOf(guardName)) ccg = _this2.ReactVueLike.flow(ccg);
          ret.push(ccg);
        }

        if (_this2._isReactVueLike(cc) && Array.isArray(cc.mixins)) {
          cc.mixins.forEach(function (m) {
            var ccg = m[guardName] || m.prototype && m.prototype[guardName];
            if (!ccg) return;
            if (_this2.ReactVueLike && !ccg.isMobxFlow && m.__flows && ~m.__flows.indexOf(guardName)) ccg = _this2.ReactVueLike.flow(ccg);
            ret.push(ccg);
          });
        }

        var ci = componentInstances[key];

        if (bindInstance) {
          if ((0, _util.isFunction)(bindInstance)) ret = ret.map(function (v) {
            return bindInstance(v, key, ci, mr);
          }).filter(Boolean);else if (ci) ret = ret.map(function (v) {
            return v.bind(ci);
          });
        }

        ret = (0, _util.flatten)(ret);
        ret.forEach(function (v) {
          return v.route = mr;
        });
        return ret;
      }; // route component


      r.components && Object.keys(r.components).forEach(function (key) {
        var c = r.components[key];
        if (!c) return;

        if (c instanceof _routeLazy.RouteLazy) {
          var lazyResovle = function lazyResovle(interceptors, index) {
            var nc, ret;
            return regeneratorRuntime.async(function lazyResovle$(_context) {
              while (1) {
                switch (_context.prev = _context.next) {
                  case 0:
                    _context.next = 2;
                    return regeneratorRuntime.awrap(c.toResolve(r, key));

                  case 2:
                    nc = _context.sent;
                    nc = _this2._callEvent('onResolveComponent', nc, r) || nc;
                    ret = toResovle(nc, key);
                    interceptors.splice.apply(interceptors, [index, 1].concat(_toConsumableArray(ret)));
                    return _context.abrupt("return", interceptors[index]);

                  case 7:
                  case "end":
                    return _context.stop();
                }
              }
            });
          };

          lazyResovle.lazy = true;
          lazyResovle.route = mr;
          ret.push(lazyResovle);
        } else ret.push.apply(ret, _toConsumableArray(toResovle(c, key)));
      });
      return ret;
    }
  }, {
    key: "_getRouteComponentGurads",
    value: function _getRouteComponentGurads(matched, guardName) {
      var _this3 = this;

      var reverse = arguments.length > 2 && arguments[2] !== undefined ? arguments[2] : false;
      var bindInstance = arguments.length > 3 && arguments[3] !== undefined ? arguments[3] : true;
      var ret = [];
      if (reverse) matched = matched.reverse();
      matched.forEach(function (r) {
        var guards = _this3._getComponentGurads(r, guardName, bindInstance);

        ret.push.apply(ret, _toConsumableArray(guards));
      });
      return ret;
    }
  }, {
    key: "_getSameMatched",
    value: function _getSameMatched(route, compare) {
      var ret = [];
      if (!compare) return [];
      route && route.matched.some(function (tr, i) {
        var fr = compare.matched[i];
        if (tr.path !== fr.path) return true;
        ret.push(tr);
      });
      return ret.filter(function (r) {
        return !r.redirect;
      });
    }
  }, {
    key: "_getChangeMatched",
    value: function _getChangeMatched(route, compare) {
      var options = arguments.length > 2 && arguments[2] !== undefined ? arguments[2] : {};
      var ret = [];
      if (!compare) return _toConsumableArray(route.matched);
      var start = false;
      route && route.matched.some(function (tr, i) {
        var fr = compare.matched[i];

        if (!start) {
          start = options.containLazy && (0, _routeLazy.hasRouteLazy)(tr) || !fr || fr.path !== tr.path;
          if (!start) return;
        }

        ret.push(tr);
        return typeof options.count === 'number' && ret.length === options.count;
      });
      return ret.filter(function (r) {
        return !r.redirect;
      });
    }
  }, {
    key: "_getBeforeEachGuards",
    value: function _getBeforeEachGuards(to, from) {
      var _this4 = this;

      var current = arguments.length > 2 && arguments[2] !== undefined ? arguments[2] : null;

      var ret = _toConsumableArray(this.beforeEachGuards);

      var view = this;

      if (from) {
        var fm = this._getChangeMatched(from, to).filter(function (r) {
          return Object.keys(r.componentInstances).some(function (key) {
            return r.componentInstances[key];
          });
        });

        ret.push.apply(ret, _toConsumableArray(this._getRouteComponentGurads(fm, 'beforeRouteLeave', true, function (fn, name, ci, r) {
          return function beforeRouteLeaveWraper(to, from, next) {
            return fn.call(ci, to, from, function (cb) {
              if ((0, _util.isFunction)(cb)) {
                var _cb = cb;

                cb = function cb() {
                  var res = _cb.apply(void 0, arguments);

                  view._callEvent('onRouteLeaveNext', r, ci, res);

                  return res;
                };
              }

              for (var _len2 = arguments.length, args = new Array(_len2 > 1 ? _len2 - 1 : 0), _key2 = 1; _key2 < _len2; _key2++) {
                args[_key2 - 1] = arguments[_key2];
              }

              return next.apply(void 0, [cb].concat(args));
            }, r);
          };
        })));
      }

      if (to) {
        var tm = this._getChangeMatched(to, from, {
          containLazy: true
        });

        tm.forEach(function (r) {
          var guards = _this4._getComponentGurads(r, 'beforeRouteEnter', function (fn, name) {
            return function beforeRouteEnterWraper(to, from, next) {
              return fn(to, from, function (cb) {
                if ((0, _util.isFunction)(cb)) {
                  var _cb = cb;

                  r.config._pending.completeCallbacks[name] = function (ci) {
                    var res = _cb(ci);

                    view._callEvent('onRouteEnterNext', r, ci, res);

                    return res;
                  };

                  cb = undefined;
                }

                for (var _len3 = arguments.length, args = new Array(_len3 > 1 ? _len3 - 1 : 0), _key3 = 1; _key3 < _len3; _key3++) {
                  args[_key3 - 1] = arguments[_key3];
                }

                return next.apply(void 0, [cb].concat(args));
              }, r);
            };
          });

          ret.push.apply(ret, _toConsumableArray(guards));
        });
      }

      return (0, _util.flatten)(ret);
    } // _getBeforeResolveGuards(to: Route, from: Route | null) {
    //   const ret = [...this.beforeResolveGuards];
    //   const view = this;
    //   if (from) {
    //     const fm = this._getChangeMatched(from, to)
    //       .filter(r => Object.keys(r.componentInstances).some(key => r.componentInstances[key]));
    //     ret.push(...(this._getRouteComponentGurads(fm, 'beforeRouteResolve'));
    //   }
    //   if (to) {
    //     let tm = this._getChangeMatched(to, from, { containLazy: true });
    //     tm.forEach(r => {
    //       let guards = this._getComponentGurads(
    //         r,
    //         'beforeRouteEnter',
    //         (fn, name) => (function beforeRouteEnterWraper(to: Route, from: Route | null, next: RouteNextFn) {
    //           return (fn as RouteBeforeGuardFn)(to, from, (cb, ...args) => {
    //             if (isFunction(cb)) {
    //               const _cb = cb;
    //               r.config._pending.completeCallbacks[name] = ci => {
    //                 const res = _cb(ci);
    //                 view._callEvent('onRouteEnterNext', r, ci, res);
    //                 return res;
    //               };
    //               cb = undefined;
    //             }
    //             return next(cb, ...args);
    //           }, r);
    //         })
    //       ) as RouteBeforeGuardFn[];
    //       ret.push(...guards);
    //     });
    //   }
    //   return flatten(ret);
    // }

  }, {
    key: "_getRouteUpdateGuards",
    value: function _getRouteUpdateGuards(to, from) {
      var ret = [];
      var fm = [];
      to && to.matched.some(function (tr, i) {
        var fr = from && from.matched[i];
        if (!fr || fr.path !== tr.path) return true;
        fm.push(fr);
      });
      ret.push.apply(ret, _toConsumableArray(this._getRouteComponentGurads(fm.filter(function (r) {
        return !r.redirect;
      }), 'beforeRouteUpdate', true)));
      return ret;
    }
  }, {
    key: "_getAfterEachGuards",
    value: function _getAfterEachGuards(to, from) {
      var ret = [];

      if (from) {
        var fm = this._getChangeMatched(from, to).filter(function (r) {
          return Object.keys(r.componentInstances).some(function (key) {
            return r.componentInstances[key];
          });
        });

        ret.push.apply(ret, _toConsumableArray(this._getRouteComponentGurads(fm, 'afterRouteLeave', true)));
      }

      ret.push.apply(ret, _toConsumableArray(this.afterEachGuards));
      return (0, _util.flatten)(ret);
    }
  }, {
    key: "_transformLocation",
    value: function _transformLocation(location) {
      if (!location) return location;

      if (this.basename) {
        if (location.pathname.indexOf(this.basename) !== 0) return null;
        location = _objectSpread({}, location);
        location.pathname = location.pathname.substr(this.basename.length) || '/';
        if (location.path !== undefined) location.path = location.pathname;
      }

      return location;
    }
  }, {
    key: "_handleRouteInterceptor",
    value: function _handleRouteInterceptor(location, callback) {
      var isInit,
          _args2 = arguments;
      return regeneratorRuntime.async(function _handleRouteInterceptor$(_context2) {
        while (1) {
          switch (_context2.prev = _context2.next) {
            case 0:
              isInit = _args2.length > 2 && _args2[2] !== undefined ? _args2[2] : false;

              if (this.isRunning) {
                _context2.next = 3;
                break;
              }

              return _context2.abrupt("return", callback(false));

            case 3:
              if (typeof location === 'string') location = _routeCache.default.flush(location);
              location = this._transformLocation(location);

              if (location) {
                _context2.next = 7;
                break;
              }

              return _context2.abrupt("return", callback(true));

            case 7:
              if (!(!isInit && !location.onInit && (!this.viewRoot || !this.viewRoot.state._routerInited))) {
                _context2.next = 9;
                break;
              }

              return _context2.abrupt("return", callback(false));

            case 9:
              this._callEvent('onRouteing', true);

              _context2.prev = 10;
              _context2.next = 13;
              return regeneratorRuntime.awrap(this._internalHandleRouteInterceptor(location, callback, isInit));

            case 13:
              return _context2.abrupt("return", _context2.sent);

            case 14:
              _context2.prev = 14;

              this._callEvent('onRouteing', false);

              return _context2.finish(14);

            case 17:
            case "end":
              return _context2.stop();
          }
        }
      }, null, this, [[10,, 14, 17]]);
    }
  }, {
    key: "_getInterceptor",
    value: function _getInterceptor(interceptors, index) {
      var interceptor;
      return regeneratorRuntime.async(function _getInterceptor$(_context3) {
        while (1) {
          switch (_context3.prev = _context3.next) {
            case 0:
              interceptor = interceptors[index];

            case 1:
              if (!(interceptor && interceptor.lazy)) {
                _context3.next = 7;
                break;
              }

              _context3.next = 4;
              return regeneratorRuntime.awrap(interceptor(interceptors, index));

            case 4:
              interceptor = _context3.sent;
              _context3.next = 1;
              break;

            case 7:
              return _context3.abrupt("return", interceptor);

            case 8:
            case "end":
              return _context3.stop();
          }
        }
      });
    }
  }, {
    key: "_routetInterceptors",
    value: function _routetInterceptors(interceptors, to, from, next) {
      var _this5 = this;

      var isBlock, beforeInterceptor;
      return regeneratorRuntime.async(function _routetInterceptors$(_context6) {
        while (1) {
          switch (_context6.prev = _context6.next) {
            case 0:
              beforeInterceptor = function _ref6(interceptor, index, to, from, next) {
                var _this6 = this;

                var nextWrapper;
                return regeneratorRuntime.async(function beforeInterceptor$(_context5) {
                  while (1) {
                    switch (_context5.prev = _context5.next) {
                      case 0:
                        if (interceptor) {
                          _context5.next = 2;
                          break;
                        }

                        return _context5.abrupt("return", next());

                      case 2:
                        nextWrapper = this._nexting = (0, _util.once)(function _callee(f1) {
                          var nextInterceptor;
                          return regeneratorRuntime.async(function _callee$(_context4) {
                            while (1) {
                              switch (_context4.prev = _context4.next) {
                                case 0:
                                  if (!isBlock.call(_this6, f1, interceptor)) {
                                    _context4.next = 2;
                                    break;
                                  }

                                  return _context4.abrupt("return", next(f1));

                                case 2:
                                  if (f1 === true) f1 = undefined;
                                  _context4.next = 5;
                                  return regeneratorRuntime.awrap(_this6._getInterceptor(interceptors, ++index));

                                case 5:
                                  nextInterceptor = _context4.sent;

                                  if (nextInterceptor) {
                                    _context4.next = 8;
                                    break;
                                  }

                                  return _context4.abrupt("return", next(function (res) {
                                    return (0, _util.isFunction)(f1) && f1(res);
                                  }));

                                case 8:
                                  _context4.prev = 8;
                                  _context4.next = 11;
                                  return regeneratorRuntime.awrap(beforeInterceptor.call(_this6, nextInterceptor, index, to, from, function (res) {
                                    var ret = next(res);
                                    if (interceptor.global) (0, _util.isFunction)(f1) && f1(res);
                                    return ret;
                                  }));

                                case 11:
                                  return _context4.abrupt("return", _context4.sent);

                                case 14:
                                  _context4.prev = 14;
                                  _context4.t0 = _context4["catch"](8);
                                  console.error(_context4.t0);
                                  next(typeof _context4.t0 === 'string' ? new Error(_context4.t0) : _context4.t0);

                                case 18:
                                case "end":
                                  return _context4.stop();
                              }
                            }
                          }, null, null, [[8, 14]]);
                        });
                        _context5.next = 5;
                        return regeneratorRuntime.awrap(interceptor(to, from, nextWrapper, interceptor.route));

                      case 5:
                        return _context5.abrupt("return", _context5.sent);

                      case 6:
                      case "end":
                        return _context5.stop();
                    }
                  }
                }, null, this);
              };

              isBlock = function isBlock(v, interceptor) {
                var _isLocation = typeof v === 'string' || (0, _util.isLocation)(v);

                if (_isLocation && interceptor) {
                  var _to = (0, _util.normalizeLocation)(v, interceptor.route);

                  v = _to && _this5.createRoute(_to);

                  if (v && v.fullPath === to.fullPath) {
                    v = undefined;
                    _isLocation = false;
                  }
                }

                return !_this5._history || v === false || _isLocation || v instanceof Error;
              };

              if (!next) {
                _context6.next = 17;
                break;
              }

              _context6.t0 = regeneratorRuntime;
              _context6.t1 = beforeInterceptor;
              _context6.t2 = this;
              _context6.next = 8;
              return regeneratorRuntime.awrap(this._getInterceptor(interceptors, 0));

            case 8:
              _context6.t3 = _context6.sent;
              _context6.t4 = to;
              _context6.t5 = from;
              _context6.t6 = next;
              _context6.t7 = _context6.t1.call.call(_context6.t1, _context6.t2, _context6.t3, 0, _context6.t4, _context6.t5, _context6.t6);
              _context6.next = 15;
              return _context6.t0.awrap.call(_context6.t0, _context6.t7);

            case 15:
              _context6.next = 18;
              break;

            case 17:
              _util.afterInterceptors.call(this, interceptors, to, from);

            case 18:
            case "end":
              return _context6.stop();
          }
        }
      }, null, this);
    }
  }, {
    key: "_internalHandleRouteInterceptor",
    value: function _internalHandleRouteInterceptor(location, callback) {
      var _this7 = this;

      var isInit = arguments.length > 2 && arguments[2] !== undefined ? arguments[2] : false;
      var isContinue = false;
      var interceptorCounter = ++this._interceptorCounter;

      try {
        var to = this.createRoute(location);
        var from = isInit ? null : to.redirectedFrom || this.currentRoute;
        var current = this.currentRoute;

        var checkIsContinue = function checkIsContinue() {
          return _this7.isRunning && interceptorCounter === _this7._interceptorCounter && Boolean(_this7.viewRoot && _this7.viewRoot._isMounted);
        };

        var afterCallback = function afterCallback(isContinue, to) {
          if (isContinue) to.onInit && to.onInit(isContinue, to);else to.onAbort && to.onAbort(isContinue, to);

          _this7.nextTick(function () {
            if (!isInit && (!current || current.fullPath !== to.fullPath)) {
              _this7._routetInterceptors(_this7._getRouteUpdateGuards(to, current), to, current);
            }
          });
        };

        if (!to) return;

        if (from && to.path === from.path) {
          isContinue = checkIsContinue();
          callback(isContinue, null);
          afterCallback(isContinue, to);
          return;
        }

        var fallbackView = null;

        if ((0, _routeLazy.hasMatchedRouteLazy)(to.matched)) {
          fallbackView = this.viewRoot;

          this._getSameMatched(isInit ? null : this.currentRoute, to).reverse().some(function (m) {
            if (!m.viewInstances.default || !m.viewInstances.default.props.fallback) return;
            return fallbackView = m.viewInstances.default;
          });
        }

        fallbackView && fallbackView._updateResolving(true);

        this._routetInterceptors(this._getBeforeEachGuards(to, from, current), to, from, function (ok) {
          _this7._nexting = null;
          fallbackView && setTimeout(function () {
            return fallbackView && fallbackView._isMounted && fallbackView._updateResolving(false);
          }, 0);
          if (typeof ok === 'string') ok = {
            path: ok
          };
          isContinue = checkIsContinue() && Boolean(ok === undefined || ok && !(ok instanceof Error) && !(0, _util.isLocation)(ok));
          var toLast = to.matched[to.matched.length - 1];

          if (isContinue && toLast && toLast.config.exact && toLast.redirect) {
            ok = (0, _util.resolveRedirect)(toLast.redirect, toLast, to);
            if (ok) isContinue = false;
          }

          callback(isContinue, to);
          afterCallback(isContinue, to);

          if (!isContinue) {
            if ((0, _util.isLocation)(ok)) {
              return _this7.redirect(ok, to.onComplete, to.onAbort, to.onInit || (isInit ? callback : null), to);
            }

            if (ok instanceof Error) _this7.errorCallback && _this7.errorCallback(ok);
            return;
          }

          _this7.nextTick(function () {
            if ((0, _util.isFunction)(ok)) ok = ok(to);
            if (to && (0, _util.isFunction)(to.onComplete)) to.onComplete(Boolean(ok), to);

            _this7._routetInterceptors(_this7._getAfterEachGuards(to, current), to, current);
          });
        });
      } catch (ex) {
        console.error(ex);
        if (!isContinue) callback(isContinue, null);
      }
    }
  }, {
    key: "_go",
    value: function _go(to, onComplete, onAbort, onInit, replace) {
      var _this8 = this;

      return new Promise(function (resolve, reject) {
        var _to = (0, _util.normalizeLocation)(to, _this8.currentRoute, false, _this8.basename);

        function doComplete(res, _to) {
          onComplete && onComplete(res, _to);
          resolve(res);
        }

        function doAbort(res, _to) {
          onAbort && onAbort(res, _to);
          reject(res === false && _to === null ? new Error('to path cannot be empty!') : res);
        }

        if (!_this8.isRunning) return doAbort(new Error('router is not running!'), null);
        if (!_to) return doAbort(false, null);
        if ((0, _util.isFunction)(onComplete)) _to.onComplete = (0, _util.once)(doComplete);
        if ((0, _util.isFunction)(onAbort)) _to.onAbort = (0, _util.once)(doAbort);
        if (onInit) _to.onInit = onInit;
        if (_this8._nexting) return _this8._nexting(_to);
        if (replace) _to.isReplace = true;

        if (!_this8.viewRoot || !onInit && !_this8.viewRoot.state._routerInited) {
          return _this8.pendingRoute = _to;
        }

        if (replace) {
          if (_to.fullPath && (0, _util.isAbsoluteUrl)(_to.fullPath)) location.replace(_to.fullPath);else _this8.history.replace(_to);
        } else {
          if (_to.fullPath && (0, _util.isAbsoluteUrl)(_to.fullPath)) location.href = _to.fullPath;else _this8.history.push(_to);
        }
      });
    }
  }, {
    key: "_replace",
    value: function _replace(to, onComplete, onAbort, onInit) {
      return this._go(to, onComplete, onAbort, onInit, true);
    }
  }, {
    key: "_push",
    value: function _push(to, onComplete, onAbort, onInit) {
      return this._go(to, onComplete, onAbort, onInit);
    }
  }, {
    key: "createMatchedRoute",
    value: function createMatchedRoute(route, match) {
      var _ref7 = match || {
        url: '',
        params: {}
      },
          url = _ref7.url,
          params = _ref7.params;

      var path = route.path,
          subpath = route.subpath,
          meta = route.meta,
          redirect = route.redirect,
          index = route.index,
          depth = route.depth;
      return {
        url: url,
        path: path,
        subpath: subpath,
        depth: depth,
        meta: meta,
        index: index,
        redirect: redirect,
        params: params,
        componentInstances: {},
        viewInstances: {},
        config: route
      };
    }
  }, {
    key: "getMatched",
    value: function getMatched(to, from) {
      var _this9 = this;

      var parent = arguments.length > 2 && arguments[2] !== undefined ? arguments[2] : null;
      if (!from) from = this.currentRoute;

      function copyInstance(to, from) {
        if (!from) return;
        if (from.componentInstances) to.componentInstances = from.componentInstances;
        if (from.viewInstances) to.viewInstances = from.viewInstances;
      }

      var matched = (0, _util.matchRoutes)(this.routes, to, parent);
      return matched.map(function (_ref8, i) {
        var route = _ref8.route,
            match = _ref8.match;

        var ret = _this9.createMatchedRoute(route, match);

        if (from) {
          var fr = from.matched[i];
          var tr = matched[i];
          if (fr && tr && fr.path === tr.route.path) copyInstance(ret, fr);
        }

        return ret;
      });
    }
  }, {
    key: "getMatchedComponents",
    value: function getMatchedComponents(to, from, parent) {
      return this.getMatched(to, from, parent).map(function (r) {
        return r.componentInstances.default;
      }).filter(Boolean);
    }
  }, {
    key: "getMatchedViews",
    value: function getMatchedViews(to, from, parent) {
      return this.getMatched(to, from, parent).map(function (r) {
        return r.viewInstances.default;
      }).filter(Boolean);
    }
  }, {
    key: "createRoute",
    value: function createRoute(to) {
      var from = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : null;
      if (!from && to) from = to.redirectedFrom || this.currentRoute;
      var matched = to ? this.getMatched(to, from) : [];
      var last = matched.length ? matched[matched.length - 1] : {
        url: '',
        params: {},
        meta: {}
      };

      var _ref9 = to || {},
          _ref9$search = _ref9.search,
          search = _ref9$search === void 0 ? '' : _ref9$search,
          query = _ref9.query,
          _ref9$path = _ref9.path,
          path = _ref9$path === void 0 ? '' : _ref9$path,
          onAbort = _ref9.onAbort,
          onComplete = _ref9.onComplete,
          isRedirect = _ref9.isRedirect,
          isReplace = _ref9.isReplace,
          onInit = _ref9.onInit;

      var ret = {
        action: this.history.action,
        url: last.url,
        basename: this.basename,
        path: path,
        search: search,
        fullPath: "".concat(path).concat(search),
        isRedirect: Boolean(isRedirect),
        isReplace: Boolean(isReplace),
        query: query || (search ? _config.default.parseQuery(search.substr(1)) : {}),
        params: last.params || {},
        matched: matched,
        meta: last.meta || {},
        onAbort: onAbort,
        onComplete: onComplete
      }; // Object.defineProperty(ret, 'fullPath', {
      //   enumerable: true,
      //   configurable: true,
      //   get() {
      //     return `${to.path}${to.search}`;
      //   }
      // });

      Object.defineProperty(ret, 'origin', {
        configurable: true,
        value: to
      });

      if (isRedirect && from) {
        ret.redirectedFrom = from;
        if (!ret.onAbort && from.onAbort) ret.onAbort = from.onAbort;
        if (!ret.onComplete && from.onComplete) ret.onComplete = from.onComplete;
        if (!ret.onInit && onInit) ret.onInit = onInit;
      }

      return ret;
    }
  }, {
    key: "updateRoute",
    value: function updateRoute(location) {
      var _this10 = this;

      location = location && this._transformLocation(location);
      if (!location) return;
      this.prevRoute = this.currentRoute;
      this.currentRoute = this.createRoute(location, this.prevRoute); // const statesLen = this.states.length + this.stateOrigin;
      // const historyLen = this.history.length - this.stateOrigin;
      // if (this.history.action === 'POP') {
      //   this.currentRoute.state = this.states[historyLen];
      //   if (statesLen > this.history.length) this.states.splice(historyLen);
      // } else {
      //   if (statesLen > this.history.length) this.states.splice(historyLen - 1);
      //   this.states.push(this.currentRoute.state);
      // }

      var tm = this.prevRoute && this._getChangeMatched(this.prevRoute, this.currentRoute, {
        count: 1
      })[0];

      var callback = function callback() {
        return _this10._callEvent('onRouteChange', _this10.currentRoute, _this10);
      };

      if (tm) {
        var keys = Object.keys(tm.viewInstances);

        if (keys.length) {
          keys.forEach(function (key, i) {
            tm && tm.viewInstances[key]._refreshCurrentRoute(undefined, undefined, i === keys.length - 1 ? callback : undefined);
          });
        } else callback();
      } else if (this.viewRoot) this.viewRoot._refreshCurrentRoute(undefined, undefined, callback);else callback();
    }
  }, {
    key: "push",
    value: function push(to, onComplete, onAbort) {
      return this._push(to, onComplete, onAbort);
    }
  }, {
    key: "replace",
    value: function replace(to, onComplete, onAbort) {
      return this._replace(to, onComplete, onAbort);
    }
  }, {
    key: "redirect",
    value: function redirect(to, onComplete, onAbort, onInit, from) {
      var _to = (0, _util.normalizeLocation)(to);

      if (!_to) return;
      _to.isRedirect = true;
      _to.redirectedFrom = from || this.currentRoute;
      return _to.isReplace ? this._replace(_to, onComplete, onAbort, onInit) : this._push(_to, onComplete, onAbort, onInit);
    }
  }, {
    key: "go",
    value: function go(n) {
      return this.history.go(n);
    }
  }, {
    key: "back",
    value: function back() {
      return this.history.goBack();
    }
  }, {
    key: "goBack",
    value: function goBack() {
      return this.history.goBack();
    }
  }, {
    key: "forward",
    value: function forward() {
      return this.history.goForward();
    }
  }, {
    key: "goForward",
    value: function goForward() {
      return this.history.goForward();
    }
  }, {
    key: "beforeEach",
    value: function beforeEach(guard) {
      if (!guard || typeof guard !== 'function') return;
      var i = this.beforeEachGuards.indexOf(guard);
      if (~i) this.beforeEachGuards.splice(i, 1);
      guard.global = true;
      this.beforeEachGuards.push(guard);
    }
  }, {
    key: "afterEach",
    value: function afterEach(guard) {
      if (!guard || typeof guard !== 'function') return;
      var i = this.afterEachGuards.indexOf(guard);
      if (~i) this.afterEachGuards.splice(i, 1);
      guard.global = true;
      this.afterEachGuards.push(guard);
    }
  }, {
    key: "addRoutes",
    value: function addRoutes(routes, parentRoute) {
      var name = arguments.length > 2 && arguments[2] !== undefined ? arguments[2] : 'default';
      if (!routes) return;
      if (!Array.isArray(routes)) routes = [routes];
      routes = (0, _util.normalizeRoutes)(routes, parentRoute);
      var children = parentRoute ? parentRoute.children : this.routes;
      if ((0, _util.isFunction)(children)) children = children();
      if (!children) return;
      routes.forEach(function (r) {
        var i = children.findIndex(function (v) {
          return v.path === r.path;
        });
        if (~i) children.splice(i, 1, r);else children.push(r);
      });
      if (parentRoute && parentRoute.viewInstances[name]) parentRoute.viewInstances[name].setState({
        routes: routes
      });else if (this.state.viewRoot) this.state.viewRoot.setState({
        routes: routes
      });
    }
  }, {
    key: "parseQuery",
    value: function parseQuery(query) {
      return _config.default.parseQuery(query);
    }
  }, {
    key: "stringifyQuery",
    value: function stringifyQuery(obj) {
      return _config.default.stringifyQuery(obj);
    }
  }, {
    key: "onError",
    value: function onError(callback) {
      this.errorCallback = callback;
    }
  }, {
    key: "install",
    value: function install(ReactVueLike, _ref10) {
      var App = _ref10.App;
      this.ReactVueLike = ReactVueLike;
      this.App = App;
      if (!App.inherits) App.inherits = {};
      App.inherits.$router = this;
      App.inherits.$route = ReactVueLike.observable(this.currentRoute || {});
      _config.default.inheritProps = false;

      if (!ReactVueLike.config.inheritMergeStrategies.$route) {
        ReactVueLike.config.inheritMergeStrategies.$route = _config.default.routeMergeStrategie;
      }

      var router = this;
      this.plugin({
        name: 'react-view-router-vue-like-plugin',
        onRouteChange: ReactVueLike.action("[react-view-router][".concat(this.id, "]onRouteChange"), function (newVal) {
          if (router.app) {
            router.app.$route = ReactVueLike.observable(newVal, {}, {
              deep: false
            });
          } else {
            App.inherits.$route = ReactVueLike.observable(newVal, {}, {
              deep: false
            });
            if (App.inherits.$router !== router) App.inherits.$router = router;
          }
        })
      });
    }
  }, {
    key: "history",
    get: function get() {
      var _this11 = this;

      if (this._history) return this._history;
      var options = this.options;

      if (options.history) {
        if (options.history instanceof ReactViewRouter) {
          this._history = options.history.history;
          this.mode = options.history.mode;
        } else this._history = options.history;
      } else {
        switch (this.mode) {
          case 'browser':
          case 'history':
            this._history = (0, _historyFix.createBrowserHistory)(this.options);
            break;

          case 'memory':
          case 'abstract':
            this._history = (0, _historyFix.createMemoryHistory)(this.options);
            break;

          default:
            this._history = (0, _historyFix.createHashHistory)(this.options);
        }
      }

      HISTORY_METHS.forEach(function (key) {
        return _this11[key] && (_this11[key] = _this11[key].bind(_this11));
      });
      return this._history;
    }
  }]);

  return ReactViewRouter;
}();

exports.default = ReactViewRouter;
//# sourceMappingURL=router.js.map